SystemOrganization addCategory: #'WebClient-SSP'!

ExternalStructure subclass: #WebClientSecBuffer
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'WebClient-SSP'!

!WebClientSecBuffer commentStamp: 'ar 9/16/2010 20:24' prior: 0!
A WebClientSecBuffer is a representation of struct SecBuffer.!

!WebClientSecBuffer class methodsFor: 'field definition' stamp: 'ar 9/16/2010 20:24'!
fields	"self defineFields"

	"Defines struct SecBuffer"

	^#(
		(cbBuffer 'ulong')
		(bufferType 'ulong')
		(pvBuffer 'void*')
	)! !

!WebClientSecBuffer methodsFor: 'accessing' stamp: 'ar 9/16/2010 20:25'!
bufferType
	"This method was automatically generated"
	^handle unsignedLongAt: 5! !

!WebClientSecBuffer methodsFor: 'accessing' stamp: 'ar 9/16/2010 20:25'!
bufferType: anObject
	"This method was automatically generated"
	handle unsignedLongAt: 5 put: anObject! !

!WebClientSecBuffer methodsFor: 'accessing' stamp: 'ar 9/16/2010 20:25'!
cbBuffer
	"This method was automatically generated"
	^handle unsignedLongAt: 1! !

!WebClientSecBuffer methodsFor: 'accessing' stamp: 'ar 9/16/2010 20:25'!
cbBuffer: anObject
	"This method was automatically generated"
	handle unsignedLongAt: 1 put: anObject! !

!WebClientSecBuffer methodsFor: 'accessing' stamp: 'ar 9/16/2010 20:25'!
pvBuffer
	"This method was automatically generated"
	^ExternalData fromHandle: (handle pointerAt: 9) type: ExternalType void asPointerType! !

!WebClientSecBuffer methodsFor: 'accessing' stamp: 'ar 9/16/2010 20:25'!
pvBuffer: anObject
	"This method was automatically generated"
	handle pointerAt: 9 put: anObject getHandle.! !

ExternalStructure subclass: #WebClientSecBufferDesc
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'WebClient-SSP'!

!WebClientSecBufferDesc commentStamp: 'ar 9/16/2010 20:24' prior: 0!
A WebClientSecBuffer is a representation of struct SecBufferDesc.!

!WebClientSecBufferDesc class methodsFor: 'field definition' stamp: 'ar 9/16/2010 20:24'!
fields	"self defineFields"

	"Defines struct SecBufferDesc"

	^#(
		(ulVersion 'ulong')
		(cBuffers 'ulong')
		(pBuffers 'void*')
	)! !

!WebClientSecBufferDesc class methodsFor: 'instance creation' stamp: 'ar 9/16/2010 21:14'!
newBuffers: count
	"Create a new SecBufferDesc with count SecBuffer elements"

	^self new initialize: count! !

!WebClientSecBufferDesc methodsFor: 'accessing' stamp: 'ar 9/16/2010 20:25'!
cBuffers
	"This method was automatically generated"
	^handle unsignedLongAt: 5! !

!WebClientSecBufferDesc methodsFor: 'accessing' stamp: 'ar 9/16/2010 20:25'!
cBuffers: anObject
	"This method was automatically generated"
	handle unsignedLongAt: 5 put: anObject! !

!WebClientSecBufferDesc methodsFor: 'initialize' stamp: 'ar 9/16/2010 21:07'!
free
	"Free the receiver"

	self freeBuffers.
	super free.
! !

!WebClientSecBufferDesc methodsFor: 'buffers' stamp: 'ar 9/16/2010 20:25'!
freeBuffers
	"Free the allocated buffers"

	self pBuffers getHandle free.

! !

!WebClientSecBufferDesc methodsFor: 'initialize' stamp: 'ar 9/16/2010 21:20'!
initialize: n
	"Initialize the buffers"

	self ulVersion: 0.
	self cBuffers: n.
	self pBuffers: (ExternalData fromHandle: 
		(ExternalAddress allocate: WebClientSecBuffer byteSize * n) 
		type: ExternalType char).

	0 to: n-1 do:[:i|
		(self secBufferAt: i)
			bufferType: 0; "SECBUFFER_EMPTY"
			cbBuffer: 0;
			pvBuffer: (ExternalData fromHandle: ExternalAddress new type: ExternalType void). "NULL"
	].! !

!WebClientSecBufferDesc methodsFor: 'accessing' stamp: 'ar 9/16/2010 20:25'!
pBuffers
	"This method was automatically generated"
	^ExternalData fromHandle: (handle pointerAt: 9) type: ExternalType void asPointerType! !

!WebClientSecBufferDesc methodsFor: 'accessing' stamp: 'ar 9/16/2010 20:25'!
pBuffers: anObject
	"This method was automatically generated"
	handle pointerAt: 9 put: anObject getHandle.! !

!WebClientSecBufferDesc methodsFor: 'buffers' stamp: 'ar 9/16/2010 20:53'!
secBufferAt: index
	"Returns the (zero-based) SecBuffer from the receiver's descriptor.
	The receiver is assumed to be created via #newBuffers:"

	| base offset |
	base := self pBuffers getHandle.
	offset := WebClientSecBuffer byteSize * index.
	^WebClientSecBuffer fromHandle: (base + offset)! !

!WebClientSecBufferDesc methodsFor: 'accessing' stamp: 'ar 9/16/2010 20:25'!
ulVersion
	"This method was automatically generated"
	^handle unsignedLongAt: 1! !

!WebClientSecBufferDesc methodsFor: 'accessing' stamp: 'ar 9/16/2010 20:25'!
ulVersion: anObject
	"This method was automatically generated"
	handle unsignedLongAt: 1 put: anObject! !

ExternalStructure subclass: #WebClientSecHandle
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'WebClient-SSP'!

!WebClientSecHandle commentStamp: 'ar 9/16/2010 21:00' prior: 0!
A WebClientSecHandle is a representation of struct SecHandle.!

!WebClientSecHandle class methodsFor: 'field definition' stamp: 'ar 9/16/2010 21:01'!
fields	"self defineFields"

	"Defines struct SecHandle"

	^#(
		(dwLower 'ulong')
		(dwUpper 'ulong')
	)! !

!WebClientSecHandle methodsFor: 'accessing' stamp: 'ar 9/16/2010 20:24'!
dwLower
	"This method was automatically generated"
	^handle unsignedLongAt: 1! !

!WebClientSecHandle methodsFor: 'accessing' stamp: 'ar 9/16/2010 20:24'!
dwLower: anObject
	"This method was automatically generated"
	handle unsignedLongAt: 1 put: anObject! !

!WebClientSecHandle methodsFor: 'accessing' stamp: 'ar 9/16/2010 20:24'!
dwUpper
	"This method was automatically generated"
	^handle unsignedLongAt: 5! !

!WebClientSecHandle methodsFor: 'accessing' stamp: 'ar 9/16/2010 20:24'!
dwUpper: anObject
	"This method was automatically generated"
	handle unsignedLongAt: 5 put: anObject! !

ExternalStructure subclass: #WebClientSecIdentity
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'WebClient-SSP'!

!WebClientSecIdentity commentStamp: 'ar 9/16/2010 20:24' prior: 0!
A WebClientAuthIdentity is a representation of struct SEC_WINNT_IDENTITY_A.!

!WebClientSecIdentity class methodsFor: 'field definition' stamp: 'ar 9/16/2010 20:23'!
fields	"self defineFields"

	"Defines struct SEC_WINNT_IDENTITY_A"

	^#(
		(user 'char*')
		(userLength 'ulong')
		(domain 'char*')
		(domainLength 'ulong')
		(password 'char*')
		(passwordLength 'ulong')
		(flags 'ulong')
	)! !

!WebClientSecIdentity methodsFor: 'accessing' stamp: 'ar 9/16/2010 20:24'!
domain
	"This method was automatically generated"
	^ExternalData fromHandle: (handle pointerAt: 9) type: ExternalType char asPointerType! !

!WebClientSecIdentity methodsFor: 'accessing' stamp: 'ar 9/16/2010 20:24'!
domain: anObject
	"This method was automatically generated"
	handle pointerAt: 9 put: anObject getHandle.! !

!WebClientSecIdentity methodsFor: 'accessing' stamp: 'ar 9/16/2010 20:24'!
domainLength
	"This method was automatically generated"
	^handle unsignedLongAt: 13! !

!WebClientSecIdentity methodsFor: 'accessing' stamp: 'ar 9/16/2010 20:24'!
domainLength: anObject
	"This method was automatically generated"
	handle unsignedLongAt: 13 put: anObject! !

!WebClientSecIdentity methodsFor: 'accessing' stamp: 'ar 9/16/2010 20:24'!
flags
	"This method was automatically generated"
	^handle unsignedLongAt: 25! !

!WebClientSecIdentity methodsFor: 'accessing' stamp: 'ar 9/16/2010 20:24'!
flags: anObject
	"This method was automatically generated"
	handle unsignedLongAt: 25 put: anObject! !

!WebClientSecIdentity methodsFor: 'accessing' stamp: 'ar 9/16/2010 20:24'!
password
	"This method was automatically generated"
	^ExternalData fromHandle: (handle pointerAt: 17) type: ExternalType char asPointerType! !

!WebClientSecIdentity methodsFor: 'accessing' stamp: 'ar 9/16/2010 20:24'!
password: anObject
	"This method was automatically generated"
	handle pointerAt: 17 put: anObject getHandle.! !

!WebClientSecIdentity methodsFor: 'accessing' stamp: 'ar 9/16/2010 20:24'!
passwordLength
	"This method was automatically generated"
	^handle unsignedLongAt: 21! !

!WebClientSecIdentity methodsFor: 'accessing' stamp: 'ar 9/16/2010 20:24'!
passwordLength: anObject
	"This method was automatically generated"
	handle unsignedLongAt: 21 put: anObject! !

!WebClientSecIdentity methodsFor: 'accessing' stamp: 'ar 9/16/2010 20:24'!
user
	"This method was automatically generated"
	^ExternalData fromHandle: (handle pointerAt: 1) type: ExternalType char asPointerType! !

!WebClientSecIdentity methodsFor: 'accessing' stamp: 'ar 9/16/2010 20:24'!
user: anObject
	"This method was automatically generated"
	handle pointerAt: 1 put: anObject getHandle.! !

!WebClientSecIdentity methodsFor: 'accessing' stamp: 'ar 9/16/2010 20:24'!
userLength
	"This method was automatically generated"
	^handle unsignedLongAt: 5! !

!WebClientSecIdentity methodsFor: 'accessing' stamp: 'ar 9/16/2010 20:24'!
userLength: anObject
	"This method was automatically generated"
	handle unsignedLongAt: 5 put: anObject! !

WebClient subclass: #WebClientSSP
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'WebClient-SSP'!

!WebClientSSP commentStamp: 'ar 9/16/2010 20:24' prior: 0!
A WebClientSSP uses Microsoft SSP to provide NTLM and Kerberos authentication on Windows.!

!WebClientSSP methodsFor: 'utilities' stamp: 'ar 9/16/2010 20:38'!
allocateBytes: bytes
	"Copy bytes to the C heap"

	| xAddr |
	xAddr := ExternalAddress allocate: bytes size.
	1 to: bytes size do:[:i| xAddr byteAt: i put: (bytes byteAt: i)].
	^ExternalData fromHandle: xAddr type: ExternalType char! !

!WebClientSSP methodsFor: 'authentication' stamp: 'ar 9/23/2010 18:45'!
aquireCredentialsHandle: params
	"Set up credentials and call AquireCredentialsHandle"

 	| method credHandle credentials err principal domain pass user |
	principal := params at: #principal ifAbsent:[nil].
	user := params at: #username ifAbsent:[''].
	pass := params at: #password ifAbsent:[''].

	"Extract the domain from username if present"
	(user notNil and:[(user indexOf: $\) > 0]) ifTrue:[
		domain := (user copyUpTo: $\) asUppercase.
		user := user copyAfter: $\.
	] ifFalse:[domain := ''].

	user ifNotEmpty:[
		credentials := WebClientSecIdentity new.
		credentials flags: 1. "SEC_WINNT_AUTH_IDENTITY_ANSI"
		credentials user: (self allocateBytes: user).
		credentials userLength: user size.
		credentials domain: (self allocateBytes: domain).
		credentials domainLength: domain size.
		credentials password: (self allocateBytes: pass value).
		credentials passwordLength: pass value size.
	].

	method := params at: #authMethod.
	credHandle := WebClientSecHandle new.
	err := self aquireCredentialsHandle: principal with: method 
			with: 2 "SECPKG_CRED_OUTBOUND" with: nil 
			with: credentials with: nil with: nil with: credHandle with: nil.
	credentials ifNotNil:[
		credentials user free.
		credentials password free.
		credentials domain free.
	].
	err = 0 ifFalse:[
		^self fail: 'AquireCredentialsHandle failed (error code: ', err hex, ')'.
	].
	^credHandle
! !

!WebClientSSP methodsFor: 'ffi calls' stamp: 'ar 9/16/2010 21:02'!
aquireCredentialsHandle: principal with: package with: fCredUse with: pLongId with: pAuthData with: pGetKey with: pGetKeyArg with: pCredhandle with: pTimestamp

	"SECURITY_STATUS SEC_ENTRY
	AcquireCredentialsHandleA(
	    __in_opt  LPSTR pszPrincipal,                 // Name of principal
	    __in      LPSTR pszPackage,                   // Name of package
	    __in      unsigned long fCredentialUse,       // Flags indicating use
	    __in_opt  void * pvLogonId,           // Pointer to logon ID
	    __in_opt  void * pAuthData,           // Package specific data
	    __in_opt  SEC_GET_KEY_FN pGetKeyFn,           // Pointer to GetKey() func
	    __in_opt  void * pvGetKeyArgument,    // Value to pass to GetKey()
	    __out     PCredHandle phCredential,           // (out) Cred Handle
	    __out_opt PTimeStamp ptsExpiry                // (out) Lifetime (optional)
	    );"
		<apicall: long 'AcquireCredentialsHandleA' (char* char* ulong void* WebClientSecIdentity* void* void* WebClientSecHandle* void*) module: 'Secur32.dll'>
		^self externalCallFailed
	! !

!WebClientSSP methodsFor: 'authentication' stamp: 'ar 9/16/2010 19:09'!
authDispatch: request from: response header: authHeader params: params
	"Dispatch on an authentication method. 
	Currently handles NTLM/Negotiate but could conceivably add Digest"

	(authHeader copyUpTo: Character space) caseOf: {
		['Negotiate'] -> [self spnegoAuth: request from: response 
							header: authHeader  params: params].
		['NTLM'] -> [self ntlmAuth: request from: response 
							header: authHeader  params: params].
	} otherwise:[
		super authDispatch: request from: response header: authHeader params: params
	].! !

!WebClientSSP methodsFor: 'ffi calls' stamp: 'ar 9/16/2010 21:02'!
deleteSecurityContext: phContext

	"SECURITY_STATUS SEC_ENTRY
	DeleteSecurityContext(
	    __in PCtxtHandle phContext               // Context to delete
	    );"

	<apicall: long 'DeleteSecurityContext' (WebClientSecHandle*) module: 'Secur32.dll'>
	^self externalCallFailed! !

!WebClientSSP methodsFor: 'utilities' stamp: 'ar 9/16/2010 20:55'!
fail: reason
	"The ongoing handshake failed due to the specified reason.
	Note the fact that it failed and return nil."

	Transcript cr; show: reason.
	^nil! !

!WebClientSSP methodsFor: 'authentication' stamp: 'ar 9/16/2010 21:42'!
flushAuthState: params
	"Fliush authentication state that should not been preserved 
	inbetween failed attempts to authenticate."

	(params removeKey: #credHandle ifAbsent:[]) 
		ifNotNil:[:h| self freeCredentialsHandle: h].
	(params removeKey: #authContext ifAbsent:[])
		ifNotNil:[:ctxt| self deleteSecurityContext: ctxt].
	super flushAuthState: params.! !

!WebClientSSP methodsFor: 'ffi calls' stamp: 'ar 9/16/2010 21:25'!
freeContextBuffer: pvContextBuffer

	"SECURITY_STATUS SEC_ENTRY
	FreeContextBuffer(
	    __inout PVOID pvContextBuffer      // buffer to free
	    );"

	<apicall: long 'FreeContextBuffer' (void*) module: 'Secur32.dll'>
	^self externalCallFailed! !

!WebClientSSP methodsFor: 'ffi calls' stamp: 'ar 9/16/2010 21:03'!
freeCredentialsHandle: phCredential

	"SECURITY_STATUS SEC_ENTRY
	FreeCredentialsHandle(
	    __in PCredHandle phCredential            // Handle to free
	    );"

	<apicall: long 'FreeCredentialsHandle' (WebClientSecHandle*) module: 'Secur32.dll'>
	^self externalCallFailed! !

!WebClientSSP methodsFor: 'ffi calls' stamp: 'ar 9/16/2010 21:04'!
initializeSecurityContext: pCredHandle with: pCtxtHandle with: pszTarget with: fCtxtReq with: reserved1 with: targetRep with: pSecBufInput with: reserved2 with: pNewCtxt with: pSecBufOutput with: pCtxtAttr with: pTimestamp

	"SECURITY_STATUS SEC_ENTRY
	InitializeSecurityContextA(
	    __in_opt    PCredHandle phCredential,               // Cred to base context
	    __in_opt    PCtxtHandle phContext,                  // Existing context (OPT)
	    __in_opt    SEC_CHAR * pszTargetName,       // Name of target
	    __in        unsigned long fContextReq,              // Context Requirements
	    __in        unsigned long Reserved1,                // Reserved, MBZ
	    __in        unsigned long TargetDataRep,            // Data rep of target
	    __in_opt    PSecBufferDesc pInput,                  // Input Buffers
	    __in        unsigned long Reserved2,                // Reserved, MBZ
	    __inout_opt PCtxtHandle phNewContext,               // (out) New Context handle
	    __inout_opt PSecBufferDesc pOutput,                 // (inout) Output Buffers
	    __out       unsigned long * pfContextAttr,  // (out) Context attrs
	    __out_opt   PTimeStamp ptsExpiry                    // (out) Life span (OPT)
	    );"
	<apicall: long 'InitializeSecurityContextA' (WebClientSecHandle* WebClientSecHandle* char* ulong ulong ulong WebClientSecBufferDesc* ulong WebClientSecHandle* WebClientSecBufferDesc* ulong* void*) module: 'Secur32.dll'>
	^self externalCallFailed! !

!WebClientSSP methodsFor: 'authentication' stamp: 'ar 9/17/2010 00:47'!
ntlmAuth: request from: response header: authHeader  params: params
	"Perform NTLM-based authentication"

	| authMethod |
	"NTLM is multi-phase, allow re-entering"
	authMethod := params at: #authMethod ifAbsentPut:['NTLM'].
	authMethod = 'NTLM' ifFalse:[^self].

	"Let SSP interface handle NTLM"
	^self sspAuth: request from: response header: authHeader  params: params! !

!WebClientSSP methodsFor: 'authentication' stamp: 'ar 9/17/2010 00:47'!
spnegoAuth: request from: response header: authHeader  params: params
	"Perform Negotiate-based authentication"

	| authMethod |
	"Negotiate is multi-phase, allow re-entering"
	authMethod := params at: #authMethod ifAbsentPut:['Negotiate'].
	authMethod = 'Negotiate' ifFalse:[^self].

	"Let SSP interface handle Negotiate"
	^self sspAuth: request from: response header: authHeader  params: params! !

!WebClientSSP methodsFor: 'authentication' stamp: 'ar 9/23/2010 18:45'!
sspAuth: request from: response header: header params: params
	"Perform Microsoft SSP based authentication"

	| err principal inFlags outFlags credHandle authContext secBufferIn secBufferOut token |
	"Kerberos service principal name"
	principal := params at: #principal ifAbsent:[nil].

	["Set up user credentials for authentication."
	credHandle := params at: #credHandle ifAbsentPut:[
		(self aquireCredentialsHandle: params) ifNil:[^self].
	].

	"Set up the SecBuffers as needed"
	secBufferIn := WebClientSecBufferDesc newBuffers: 2.
	secBufferOut := WebClientSecBufferDesc newBuffers: 2.
	(secBufferOut secBufferAt: 0) bufferType: 2. "SECBUFFER_TOKEN"

	"In- and output flags"
	inFlags := 16r100. "ISC_REQ_ALLOCATE_MEMORY"
	outFlags := WordArray with: 0.

	authContext := params at: #authContext ifAbsent:[nil].
	authContext ifNil:[	
		"This is the meat of the operation. Call InitializeSecurityContext.
		This version is only called the first time, when no context has
		been established yet."
		params at: #authContext put: (authContext := WebClientSecHandle new).
		err := self initializeSecurityContext: credHandle with: nil with: principal
				with: inFlags with: 0 with: 0 "SECURITY_NETWORK_DREP"
				with: nil with: 0 with: authContext with: secBufferOut
				with: outFlags with: nil.

		"The ONLY expected return code is SEC_I_CONTINUE_NEEDED
		since we've just started the handshake. This would be different
		if we'd allow Digest auth via SSP here but Digest is handled directly
		(although we could change this to take advantage of SSO for Digest)"

		err = 16r90312 "SEC_I_CONTINUE_NEEDED" ifFalse:[
			^self fail: 'InitializeSecurityContext returned ', err hex.
		].
	] ifNotNil:[

		"A later part of multi-leg authentication. Slightly different from the
		first time version since we need to pass in the auth token provided
		by the remote party"
		token := (header copyAfter: Character space) base64Decoded.

		"An empty token during an ongoing SSP handshake indicates invalid credentials"
		token ifEmpty:[^self fail: 'Empty token (invalid credentials)'].

		"Set up the security buffer"
		(secBufferIn secBufferAt: 0)
			bufferType: 2; "SECBUFFER_TOKEN"
			cbBuffer: token size;
			pvBuffer: (self allocateBytes: token).

		err := self initializeSecurityContext: credHandle with: authContext with: principal
				with: inFlags with: 0 with: 0 "SECURITY_NETWORK_DREP"
				with: secBufferIn with: 0 with: nil with: secBufferOut
				with: outFlags with: nil.
		err < 0 ifTrue:[^self fail: 'InitializeSecurityContext returned ', err hex].
	].

	"Handle completion if needed."
	(err = 16r90313 		"SEC_I_COMPLETE_NEEDED" 
		or:[err = 16r90314 "SEC_I_COMPLETE_AND_CONTINUE"]) ifTrue:[ | status |
			status := self completeAuthToken: authContext with: secBufferOut.
			status < 0 ifTrue:[^self fail: 'CompleteAuthToken returned ', status hex].
	].

	"We only accept a handful of codes as success"
	(err = 0 "SEC_E_OK" 
		or:[err = 16r90312 "SEC_I_CONTINUE_NEEDED"]
		or:[err = 16r90313 "SEC_I_COMPLETE_NEEDED"]
		or:[err = 16r90314 "SEC_I_COMPLETE_AND_CONTINUE"]) ifFalse:[
			^self fail: 'CompleteAuthToken returned ', err hex
	].

	"See if the call to InitializeSecurityContext produced an output token.
	If so, send it to the remote to deal with the data blob."
	0 to: secBufferOut cBuffers-1 do:[:i| | buf |
		buf := secBufferOut secBufferAt: i.
		buf bufferType = 2 "SECBUFFER_TOKEN" ifTrue:[ | ptr |
			ptr := buf pvBuffer getHandle.
			token := ByteArray new: buf cbBuffer.
			1 to: buf cbBuffer do:[:b| token byteAt: b put: (ptr byteAt: b)].
			self freeContextBuffer: buf pvBuffer.
			params at: #authResponse put: 
				(Base64MimeConverter mimeEncode: token readStream multiLine: false) contents
		].
	].
	secBufferIn free.
	secBufferOut free.
	] ifCurtailed:[
		"Free intermediate state if curtailed"
		(params removeKey: #credHandle ifAbsent:[]) 
			ifNotNil:[:h| self freeCredentialsHandle: h].
		(params removeKey: #authContext ifAbsent:[])
			ifNotNil:[:ctxt| self deleteSecurityContext: ctxt].
	].
! !
